## Overview

**ONLYOFFICE Document Server** is an online office suite comprising viewers and editors for texts, spreadsheets and presentations, fully compatible with Office Open XML formats: .docx, .xlsx, .pptx and enabling collaborative editing in real time. This document provides the roadmap of the planned **ONLYOFFICE Document Server** changes.

## Version 5.5

### Common tasks for all editors

* Bug fixes
* 3D in AutoShapes and pictures
* Mobile versions (improvements)
* Equation editor (AutoCorrect)
* Undo/redo for fast collaborative editing 
* Development of plugins (Thesaurus, DocuSign, Sent to, show the statistics of words/symbols for the selected text)
* Draw attention of the users in comments with the help of @username (@mentions)

### Document Editor improvement tasks

* Setting custom column width (row height) in the table
* Distribute column (Distribute row) in the table
* Forms
* Formulas in tables

### Spreadsheet Editor improvement tasks

* Print (preview + header/footer + page breaks)
* Adjustable cells format (numerical, monetary, etc.)
* Improvement of auto-filters (there are no settings of style parameters for spreadsheets, spreadsheet resize using mouse, the auto-adding of lines within the formatted spreadsheets)
* Pivot tables
* Conditional formating (rework)
* Modify the algorithm of auto-filling (make various options, for example, copy formatting only)
* Spelling check

### Presentation Editor improvement tasks

* Automatically fit text size in AutoShape
* Improvement of hyperlinks (internal links - an analog of the ability to assign actions to inserted objects)

### Desktop and mobile editors tasks

* Development of interface for presentation editor for iPad
* Print preview in all desktop editors


## Planned for future versions

### Server tasks

* Security
* Opening files on client (loading images, shapes and charts)

### Common tasks for all editors

* Bug fixes
* Speedup on drawing and loading
* 3D in AutoShapes and pictures
* Mobile versions (improvement)
* Improvement to the asian (Korean, Chinese and Japanese) and arabic languages support (vertical text + right-to-left)
* Improvement to  the asian languages support (Korean, Chinese and Japanese) (canvas-based font rendering)
* Border styles (double)
* Paste options (keep source formatting, merge formatting, keep text only, etc.)
* Document templates
* Development of editors add-ons for versioning (Chrome & Mozilla)
* Undo/redo for fast collaborative editing 
* Commenting mode (restricted editing)
* Protecting parts of a document from being edited
* Protecting parts of a document from being copied
* PDF editor
* Comparing two documents (+merge)
* Opening files on client
* Development of plugins (Thesaurus, DocuSign, Sent to, show the statistics of words/symbols for the selected text)
* Divide the file settings and the user settings (will be applied to all the files independent of the browser and the computer)

### Document Editor improvement tasks

* Review (rework)
* Footnotes (endnotes)
* The exact height of the rows in the table
* Support of % in brush
* Backgrounds
* Different underlining (double line, wavy line, etc.)
* Frames for pictures, templates
* Inextricable paragraph (wrap)
* Links between the titles
* Improvement for the insertion of pictures (search via internet, add from ONLYOFFICE, download pictures from the document, ClipArt)
* Hidden text
* AutoCorrect
* Watermarks (interface)
* Forms
* Fields
* Drawing canvas support

### Spreadsheet Editor improvement tasks

* Effects (like in MS Office 2013)
* Backgrounds
* Formula bar (improvements)
* Version history
* Review
* Conditional formating (rework)
* Data
* Sheet and data protection
* Splitting the window for several editors
* Forms

### Presentation Editor improvement tasks

* Vertical text
* Animation
* Header/footer + slide number + date and time
* Video + audio
* Themes
* Theme editor
* SmartArt support

### Interface tasks
* Customization
* Adding the information about updates in a new editor version
* Toolbar adaptation for various screen resolutions

### Desktop and mobile editors tasks
* Development of interface for document editor for Android
* Development of interface for spreadsheet and presentation editors for Android
* Development of SDK and API of general files manager for all editors on base of WebDAV (for usability by integrators)

## Project Information

Official website: [http://www.onlyoffice.org](http://onlyoffice.org "http://www.onlyoffice.org")

Code repository: [https://github.com/ONLYOFFICE/DocumentServer](https://github.com/ONLYOFFICE/DocumentServer "https://github.com/ONLYOFFICE/DocumentServer")

Docker Image: [https://github.com/ONLYOFFICE/Docker-DocumentServer](https://github.com/ONLYOFFICE/Docker-DocumentServer "https://github.com/ONLYOFFICE/Docker-DocumentServer")

License: [GNU AGPL v3.0](https://help.onlyoffice.com/products/files/doceditor.aspx?fileid=4358397&doc=K0ZUdlVuQzQ0RFhhMzhZRVN4ZFIvaHlhUjN2eS9XMXpKR1M5WEppUk1Gcz0_IjQzNTgzOTci0 "GNU AGPL v3.0")

SaaS version: [http://www.onlyoffice.com](http://www.onlyoffice.com "http://www.onlyoffice.com")

## User Feedback and Support

If you have any problems with or questions about [ONLYOFFICE Document Server][2], please visit our official forum to find answers to your questions: [dev.onlyoffice.org][1] or you can ask and answer ONLYOFFICE development questions on [Stack Overflow][3].

  [1]: http://dev.onlyoffice.org
  [2]: https://github.com/ONLYOFFICE/DocumentServer
  [3]: http://stackoverflow.com/questions/tagged/onlyoffice 
